function [tau_Z, PID_out] = autoDepth(z, z_d, PID)

dt = 0.02;
e = z_d - z;

%With qualisys rig
% if abs(e) < 0.1
%     Kp = 850;
%     Ki = 30;
%     Kd = 1000;
% else
%     Kp = 400;
%     Ki = 0;
%     Kd = 400;
% end

%With rig, this is better 
Kp = 1000;
Ki = 35;
Kd = 900;


%Derivative
e_dot = (e - PID.preError)/dt;

%Integralet bygger seg opp litt før?
if abs(e) < 0.15
    int = PID.integral + (e*dt); %Forward Euler
else
    int = 0;
    PID.integral = 0;
end

P = max(min(Kp*e,100),-100);
D = max(min(Kd*e_dot, 100), -100);
I = max(min(Ki*int, 100), -100);

Z = -P - D - I;


tau_Z = (max(min(Z,10),-60)) - 25; %saturation

% fprintf('_Depth_ P: %.2f \t D: %.2f \t I: %.2f \t Tot: %.0f \t err: %.2f \n', Kp*e, Kd*e_dot, Ki*int, Z, e);


%Update struct with previous error and integral
PID_out.preError = e;
PID_out.integral = int;



end