
%If position data not available, use the previous heading and position that was
%measured, if it was measured less than DT seconds ago.

DT = 1; 

if isnan(psi)
    [x, y, z, psi] = prevPos(DT, dataMatrix);
    if isnan(x) 
        j = j + 1;
        time = time + toc(loop.Timer);
        dataMatrix(j+1,:) = [time, x_d, x, y_d, y, z_d, z, psi_d, psi, depth, j];     
        inputData(j+1,:)  = [time, u(1), u(2), u(3)];    
        forceData(j+1,:)  = [time, N1, N2, N3, j];
    end
    %'e_dot is 0' 
end
%char(968) & 936;
psi_d = atan2(y_d - y, x_d - x);
% psi_d = pi/2;
e_psi = rad2pipi(psi_d - psi);

if ~isnan(psi)
    [N1, N2, PID.Heading] = autoHeading(e_psi, PID.Heading);
else
    N1 = 0;
    N2 = 0;
    mode.Heading = changeMode(mode.Heading);
    psi_d =  NaN;
end

u(1) = u(1) + N1;
u(2) = u(2) + N2; %Allows for heading control while moving forward