%CLASS_INTERFACE Example MATLAB class wrapper to an underlying C++ class
classdef interface_joystick < handle
    properties (SetAccess = private, Hidden = true)
        joy_fd; % Handle to the underlying C++ class instance
        js;
        axis;
        buttons;
    end
    methods
        %% Constructor - Create a new C++ class instance 
        function this = joystick_class_interface(varargin)
            [this.joy_fd, this.js] = joystick_class_interface_mex('new', varargin{:});
            this.axis = zeros(4,1);
            this.buttons = zeros(17,1);
            types;
        end
        
        %% Destructor - Destroy the C++ class instance
        function delete(this)
            joystick_class_interface_mex('delete', this.joy_fd, this.js);
        end

        %% Train - an example class method call
        function read_joystick_data(this, varargin)
            [type, number, value] = joystick_class_interface_mex('read_joystick_data', this.joy_fd, this.js, varargin{:});
            if type == 1
                this.axis(number) = value;
            elseif type == 2
                this.buttons(number) = value;
            end
        end
        
        %% Get()-functions
        function val = getAxisValue(this, index)
            val = this.axis(index);
        end
        function val = getButton(this, index)
            val = this.buttons(index);
        end
    end
end
