%CLASS_INTERFACE Example MATLAB class wrapper to an underlying C++ class
classdef interface_videoray < handle
    properties (SetAccess = private, Hidden = true)
        objectHandle; % Handle to the underlying C++ class instance
        status;
    end
    methods
        %% Constructor - Create a new C++ class instance 
        function this = videoray_class_interface(varargin)
            [this.objectHandle,this.status] = videoray_class_interface_mex('new', varargin{:});
        end
        
        %% Destructor - Destroy the C++ class instance
        function delete(this)
            videoray_class_interface_mex('delete', this.objectHandle, this.status);
        end

        %% Train - an example class method call
        function [roll, pitch, heading, a_surge, a_sway, a_heave, a_roll, a_pitch , a_heading, mag_x, mag_y, mag_z, depth] = read_IMU_data(this, varargin)
                 [roll, pitch, heading, a_surge, a_sway, a_heave, a_roll, a_pitch , a_heading, mag_x, mag_y, mag_z, depth] = videoray_class_interface_mex('read_IMU_data', this.objectHandle, this.status, varargin{:});
                 %Replace with struct: vr.data
        end
        
        %% Depth
        function [depth] = read_depth_data(this, varargin)
            [depth] = videoray_class_interface_mex('read_depth_data', this.objectHandle, this.status, varargin{:});
        end
        
        %% Send navDataCommand
        function setThruster(this, u)
            videoray_class_interface_mex('setThruster', this.objectHandle, this.status, u);
        end
        
        function setLights(this, currentLight, changeLight)
            videoray_class_interface_mex('setLight', this.objectHandle, this.status, currentLight, changeLight);
        end
    end
end