%% Simple thruster allocation for the steering the Videoray Pro 4 ROV 

% Created by Bent O. Arnesen
% Date: July/August, 2015
% General remarks: Do not use, abuse or distribute without proper reference

% Input : joystick values
% Output: the unconstrained thrust to be allocated to each thruster
function v = joystickAllocation(u)

    v = [min(max( u(1)-u(2), -100), 100); %Thruster 1
         min(max(-u(1)-u(2), -100), 100); %Thruster 2
         min(max(-u(3), -100), 100); %Heave thruster
         0]; %Lateral thruster
end
   
%May also be used?
%     v(1) = (u(1)-u(2));%*100/32767;  %Thruster1
%     v(2) = -(u(1)+u(2));%*100/32767;  %Thruster2
%     v(3) = -u(3);%*100/32767;        %Lateral
%     v(4) = -u(4);%*100/32767;        %Heave
    




