%% Main file for the Videoray Pro 4 ROV in Matlab.

% Created by Bent O. Arnesen
% Date: January, 2016
% General remarks: Do not use, abuse or distribute without proper reference

%1) Starts with clearing and unlocking mex functionality. 
%2) Creates mex objects, initializes controllers and controller modes, 
%   establishes contact with Qualisys 
%3) Calls the script to run through the control loop

clear all; munlock all; 
!synclient HorizEdgeScroll=0 HorizTwoFingerScroll=0 

%% Create mex objects, initialize variables and connect to Qualisys
mex videoray_class_interface_mex.cpp  src/Packetizer.cpp src/serialib.cpp src/VideoRayComm.cpp -Ilib;
vr = videoray_class_interface();
mex joystick_class_interface_mex.cpp -Ilib;
js = joystick_class_interface();

types;                             %Initialize PS3-joystick buttons 
PID  = initializeController(); %Initialize controller(s)
mode = initializeModes();      %Initialize modes

qualisys_initialize();
[x, y, z, psi] = qualisysGetData(sub);

%% Control loop
% VR_operator; %Manual control only
VR_control;    %Full system