function [x, y, z, psi] = qualisysGetData(sub)

try
    VR  = receive(sub, 0.035); %Timeout 
    
    x = VR.Position.X; 
    y = VR.Position.Y; 
    z = VR.Position.Z;
    
    q1 = [VR.Orientation.W VR.Orientation.X VR.Orientation.Y VR.Orientation.Z];
    q2 = quat2eul(q1);
    psi = rad2pipi(q2(1)+2.094); % 125deg = 2.1817, 130deg = 2.2689
    
catch
    x   = NaN; %Observer eller bruke acc måling med LP filter og passert tid
    y   = NaN;
    z   = NaN;
    psi = NaN;
end

end