% Created by Bent O. Arnesen
% Date: March, 2016
% General remarks: Do not use, abuse or distribute without proper reference

close all;

%% simulationPlot_videoray() plot file

% Load files 
for a = 1:1
eta = load('eta.mat');
nu = load('nu.mat');

pos_error   = load('pos_error.mat');
psi_error   = load('psi_error.mat');
depth_error = load('depth_error.mat');

WP = load('WP.mat');
depth_d = load('depth_d.mat');
psi_d = load('psi_d.mat');

tau = load('tau.mat');

% Define colors
orange = [0.9100   0.4100    0.1700];
end

% % eta plot
% figure(1);
% for a = 1:1
% clf;
% 
% %x plot
% subplot(4,1,1)
% hold on
% grid on
% ylabel('Position[m]')
% 
% plot(eta.ans(1,:), eta.ans(3,:), 'LineWidth', 1.5);
% plot(WP.ans(1,:), WP.ans(3,:), 'color', [0.5 0 0.5], 'LineWidth', 1.5);
% 
% legend('x', 'x_d')
% %axis([-inf inf -inf max(max(eta.ans(:,2),max(WP.ans(:,2))))]);
% 
% %y plot
% subplot(4,1,2)
% hold on
% grid on
% 
% plot(eta.ans(1,:), eta.ans(2,:), 'LineWidth', 1.5);
% plot(WP.ans(1,:), WP.ans(2,:), 'color', orange, 'LineWidth', 1.5);
% ylabel('Position[m]')
% legend('y', 'y_d')
% %axis([-inf inf -inf inf]); %max(max(eta.ans(:,3)),max(WP.ans(:,3)))]);
% 
% %Depth
% subplot(4,1,3)
% hold on
% grid on
% 
% plot(eta.ans(1,:), (eta.ans(4,:)), 'LineWidth', 1.5);
% plot(WP.ans(1,:),  WP.ans(4,:), 'LineWidth', 1.5);
% ylabel('Position[m]')
% legend('z', 'z_d')
% axis([-inf inf -inf inf]);
% 
% %Heading plot
% subplot(4,1,4)
% hold on
% grid on
% xlabel('Time [s]')
% ylabel('Orientation[deg])')
% 
% plot(eta.ans(1,:), rad2deg(rad2pipi(eta.ans(5,:))), 'LineWidth', 1.5);
% plot(psi_d.ans(1,:), rad2deg(rad2pipi(psi_d.ans(2,:))), 'LineWidth', 1.5);
% 
% legend('\psi', '\psi_d')
% axis([-inf inf -inf inf]);
% %set(gca,'YTick',[-180 180])
% end

% XY Waypoint plot
for a = 1:1
fig2 = figure(2);
set(fig2,'visible','off') % Don't show this
clf;
hold on;
grid on;
ylabel('North [m]')
xlabel('East [m]')

% XY position
plot(eta.ans(3,:), eta.ans(2,:), 'LineWidth', 1);
plot(WP.ans(3,:), WP.ans(2,:), 'color', [0.9100   0.4100    0.1700], 'LineWidth', 1.5, 'Marker', 'o');

legend('Position', 'Shortest path to WP')

waypoints = [eta_0(1) eta_0(2) eta_0(3); waypoints];
k = length(waypoints);

 for j = 1:k
     if j == 1
        txt = cellstr('WP Start');
     else
        txt = cellstr(strcat('WP ', num2str(j-1)));
     end
     text(waypoints(j,2)+0.05,waypoints(j,1)+0.08,txt)
     %plot(WP(j,2), WP(j,3), 'Color', 'b', 'Marker', 'o');
 end
 end

 % Path length calculation
 for a = 1:1
 
path_3D = 0; %Length of path
path_2D = 0;
for j = 2:k
   path_3D = path_3D + sqrt((waypoints(j,1) - waypoints(j-1,1))^2 + (waypoints(j,2) - waypoints(j-1,2))^2 + (waypoints(j,3) - waypoints(j-1,3))^2);
   path_2D = path_2D + sqrt((waypoints(j,1) - waypoints(j-1,1))^2 + (waypoints(j,2) - waypoints(j-1,2))^2);
end
txt = cellstr(strcat('Path length (2D) (m):  ', num2str(path_2D)));
text( 1, 0.6, txt);

path_traveled_2D = 0; %Length traveled
path_traveled_3D = 0;
for i = 2:length(eta.ans(1,:))
    path_traveled_2D = path_traveled_2D + sqrt((eta.ans(2,i) - eta.ans(2,i-1))^2 + (eta.ans(3,i) - eta.ans(3,i-1))^2);
    path_traveled_3D = path_traveled_3D + sqrt((eta.ans(2,i) - eta.ans(2,i-1))^2 + (eta.ans(3,i) - eta.ans(3,i-1))^2 + ((eta.ans(4,i) - eta.ans(4,i-1))^2));
end
txt = cellstr(strcat('Distance traveled (2D) (m):  ', num2str(path_traveled_2D)));
text( 1, 0.4, txt);

% time_traveled = 0;
% for i = 2:length(eta.ans(1,:))
%     if ((eta.ans(2,i) - eta.ans(2,i-1))^2 + (eta.ans(3,i) - eta.ans(3,i-1))^2 + ((eta.ans(4,i) - eta.ans(4,i-1))^2) < 0.03)
%         time_traveled = eta.ans(1,i);
%     end
% end
% txt = cellstr(strcat('Time traveled (s):  ', num2str(time_traveled)));
% text( 1, 0.2, txt);
end

% Force plot
for a = 1:1
% figure(4);
% clf; 
% 
% % x force
% subplot(3,1,1)
% ylabel('Force[N]')
% plot(tau.ans(1,:), tau.ans(2,:), 'LineWidth', 1.5);
% legend('tau_X')
% axis([-inf inf -inf max(tau.ans(2,:))]);
% grid on
% 
% % z force
% subplot(3,1,2)
% ylabel('Force[N]')
% plot(tau.ans(1,:), tau.ans(4,:), 'LineWidth', 1.5, 'Color', 'g');
% legend('tau_Z')
% axis([-inf inf -inf inf]);
% grid on
% 
% % yaw force
% subplot(3,1,3)
% ylabel('Force[N]')
% plot(tau.ans(1,:), tau.ans(5,:), 'LineWidth', 1.5, 'color', 'r');
% legend('tau_N')
% axis([-inf inf -inf inf]);
% grid on
end

% Velocity plot
for a = 1:1
figure(5);
clf;

% x force
subplot(4,1,1)
hold on
ylabel('Velocity [m/s]', 'Interpreter','latex')
xlabel('Time [s]', 'Interpreter','latex')
plot(nu.ans(1,:), nu.ans(2,:), 'LineWidth', 1.5);
legend('u')
axis([-inf inf -inf max(nu.ans(2,:))]);
grid on

% y force
subplot(4,1,2)
hold on
ylabel('Velocity [m/s]')
plot(nu.ans(1,:), nu.ans(3,:), 'LineWidth', 1.5);
legend('v')
axis([-inf inf -inf max(nu.ans(3,:))]);
grid on

%Depth
subplot(4,1,3)
hold on
ylabel('Velocity [m/s]', 'Interpreter','latex')
plot(nu.ans(1,:), nu.ans(4,:), 'LineWidth', 1.5');
legend('w')
axis([-inf inf -inf max(nu.ans(4,:))]);
grid on

% Heading plot
subplot(4,1,4)
hold on
ylabel('Velocity (rad/s)', 'Interpreter','latex')
xlabel('Time [s]', 'Interpreter','latex')
plot(nu.ans(1,:), nu.ans(5,:), 'LineWidth', 1.5);
legend('r')
axis([-inf inf -inf max(nu.ans(5,:))]);
grid on
end

% Depth controller plot
for a = 1:1
% figure(6)
% clf
% hold on
% grid on
% 
% %Depth position
% subplot(3,1,1)
% hold on
% grid on
% 
% plot(eta.ans(1,:), -(eta.ans(4,:)), 'LineWidth', 1.5);
% plot(WP.ans(1,:),  -WP.ans(4,:), 'LineWidth', 1.5);
% ylabel('Depth [m]', 'interpreter', 'latex')
% legend('z', 'z_d')
% axis([-inf inf -inf inf]);
% 
% %Depth error
% subplot(3,1,2)
% hold on
% ylabel('Depth error [m]', 'interpreter', 'latex')
% plot(depth_error.ans(1,:), depth_error.ans(2,:), 'LineWidth', 1.5, 'Color', 'g');
% legend('Depth error')
% axis([-inf inf -inf inf]);
% grid on
% 
% %Depth force
% subplot(3,1,3)
% hold on
% ylabel('Force [N]', 'interpreter', 'latex')
% xlabel('Time [s]', , 'interpreter', 'latex')
% plot(tau.ans(1,:), tau.ans(4,:), 'LineWidth', 1.5, 'Color', 'r');
% legend('tau_Z')
% axis([-inf inf -inf inf]);
% grid on
end

% Heading controller plot
for a = 1:1
% figure(8)
% clf
% hold on
% grid on
% 
% %Depth position
% subplot(3,1,1)
% hold on
% grid on
% plot(eta.ans(1,:), rad2deg(rad2pipi(eta.ans(5,:))), 'LineWidth', 1.5);
% plot(psi_d.ans(1,:), rad2deg(rad2pipi(psi_d.ans(2,:))), 'LineWidth', 1.5);
% ylabel('Angle[deg]')
% legend('\psi', '\psi_d')
% axis([-inf inf -inf inf]);
% 
% %Heading error
% subplot(3,1,2)
% hold on
% ylabel('Error [deg]')
% plot(psi_error.ans(1,:), rad2deg(psi_error.ans(2,:)), 'LineWidth', 1.5, 'Color', 'g');
% legend('Heading error')
% axis([-inf inf -inf inf]);
% grid on
% 
% %heading force
% subplot(3,1,3)
% hold on
% plot(tau.ans(1,:), tau.ans(5,:), 'LineWidth', 1.5, 'Color', 'r');
% legend('tau_N')
% axis([-inf inf -inf inf]);
% xlabel('Time[s]')
% ylabel('Momentum[Nm]')
% grid on
end

%% XYZ Position and heading plot
figure(9);
clf;

%XY position
subplot(3,1,1);
% clf;
hold on
grid on
ylabel('X-position [m]', 'Interpreter','latex')
xlabel('Y-position [m]', 'Interpreter','latex')

plot(eta.ans(3,:), eta.ans(2,:), 'LineWidth', 1.6);
plot(WP.ans(3,:), WP.ans(2,:), 'color', [0.9100   0.4100    0.1700], 'LineWidth', 1, 'Marker', 'o');

legend('ROV Position', 'Path and waypoints')

%Text WP in plot
 for jj = 1:k
     if jj == 1
        txt = cellstr('Start');
     else
        txt = cellstr(strcat('WP ', num2str(jj-1)));
     end
     text(waypoints(jj,2)+0.04,waypoints(jj,1)+0.08,txt)
     %plot(WP(j,2), WP(j,3), 'Color', 'b', 'Marker', 'o');
 end

 camroll(180);
 set(gca, 'xdir', 'reverse');
 set(gca,'YAxisLocation','right')
 axis([-1.5 1 3.5 7 ])

%Depth
subplot(3,1,2);
hold on
grid on

plot(eta.ans(1,:), -(eta.ans(4,:)), 'LineWidth', 1.5, 'Color', 'g');
plot(WP.ans(1,:),  -WP.ans(4,:), 'LineWidth', 1, 'Color', 'r');
ylabel('Depth - [m]', 'Interpreter','latex')
xlabel('Time [s]', 'Interpreter','latex')
legend('Depth', 'Desired depth')
axis([-inf inf -0.25 0.02]);

%Heading
subplot(3,1,3)
hold on
grid on
xlabel('Time [s]', 'Interpreter','latex')
ylabel('Heading - [deg]', 'Interpreter','latex')
axis([0 inf -180 180])

plot(eta.ans(1,:), rad2deg(rad2pipi(eta.ans(5,:))), 'LineWidth', 1.5);
plot(psi_d.ans(1,:), rad2deg(rad2pipi(psi_d.ans(2,:))), 'LineWidth', 1.5);

legend('\psi', '\psi_d')
axis([-inf inf -inf inf]);